// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "slovnik.h"
#include "ChildView.h"
#include "WordDialog.h"
#include "FindWordDiag.h"
#include "WordData.h"
#include "TemataDiag.h"
#include "ZaradDiag.h"
#include "ZkouseniDiag.h"
#include "VyberTemaDiag.h"
#include "PridatHesloDiag.h"
#include "UceniDiag.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define IDC_SEARCHLISTBOX 100


/////////////////////////////////////////////////////////////////////////////
// CChildView

CChildView::CChildView()
{
 if (!NadpisFont.CreatePointFont(140,"Arial Bold")) MessageBox("Nemuzu vytvorit font pro Nadpis.");
 if (!TextFont.CreatePointFont(100,"Arial")) MessageBox("Nemuzu vytvorit font pro Text.");
 if (!BoldTextFont.CreatePointFont(100,"Arial Bold")) MessageBox("Nemuzu vytvorit font pro Bold Text.");
 bFirstUpdate=true;
 VyskaSlov=0;
 OpenFile="Bezjmena";
 HasName=false;
 WasChanged=false;
 Slovnik.InitHashTable(1701);
}

CChildView::~CChildView()
{
}


BEGIN_MESSAGE_MAP(CChildView,CWnd )
	//{{AFX_MSG_MAP(CChildView)
	ON_WM_PAINT()
	ON_WM_CREATE()
	ON_COMMAND(ID_NEWWORD, OnNewWord)
	ON_WM_SIZE()
	ON_WM_VSCROLL()
	ON_COMMAND(ID_EDITWORD, OnEditWord)
	ON_COMMAND(ID_DELETEWORD, OnDeleteWord)
	ON_COMMAND(ID_NEWDICT, OnNewDict)
	ON_COMMAND(ID_SAVEDICTAS, OnSaveDictAs)
	ON_COMMAND(ID_OPENDICT, OnOpenDict)
	ON_COMMAND(ID_MERGEDICT, OnMergeDict)
	ON_COMMAND(ID_SAVEDICT, OnSaveDict)
	ON_COMMAND(ID_FINDWORD, OnFindWord)
	ON_COMMAND(ID_ZARAD, OnZarad)
	ON_COMMAND(ID_TEMATA, OnTemata)
	ON_COMMAND(ID_ZKOUSENI, OnZkouseni)
	ON_WM_CLOSE()
	ON_COMMAND(ID_UCENI, OnUceni)
	//}}AFX_MSG_MAP
	ON_LBN_SELCHANGE(IDC_SEARCHLISTBOX,OnLBNSelChange)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.style |= WS_VSCROLL;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	dc.SetWindowOrg(0,VScrollPos);
	// TODO: Add your message handler code here
    if(!bFirstUpdate) UpdateTexts(&dc,CurrWord);
	// Do not call CWnd::OnPaint() for painting messages
}


int CChildView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd ::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	CRect rect(0,0,195,310);
	SearchList.CreateEx (WS_EX_CLIENTEDGE, _T ("LISTBOX"), NULL,
    WS_CHILD | WS_VISIBLE | LBS_STANDARD, rect, this, IDC_SEARCHLISTBOX);	
    char LastFile[129];
    GetPrivateProfileString("Slovnik","LastFile","Bezjmena",LastFile,
		                    128,"./slovnik.ini");
	if (strcmp(LastFile,"Bezjmena")!=0) {
		if (LoadDictionary(LastFile)) {
		 HasName=true;
         WasChanged=false;
         OpenFile=LastFile;
		}
		}
	char titulek[128]="Slovnik - ";
    strcat(titulek,OpenFile);
   ::AfxGetMainWnd()->SendMessage(WM_SETTEXT,0,(long)titulek);
	return 0;
}

void CChildView::OnNewWord() 
{
// TODO: Add your command handler code here
CWordDialog wd;
if (wd.DoModal()==IDOK){
int i=SearchList.AddString(wd.KeyWord);
CWordData wrk(wd.KeyWord,&wd.Vyznamy,wd.PocetVyznamu,i);
Slovnik[wd.KeyWord]=wrk;
WasChanged=true;
char titulek[128]="Slovnik - ";
strcat(titulek,OpenFile);
strcat(titulek,"*");
::AfxGetMainWnd()->SendMessage(WM_SETTEXT,0,(long)titulek);

}
}

afx_msg void CChildView::OnLBNSelChange()
{
 int CurSelection;
 CString wrk;

 CurSelection=SearchList.GetCurSel();
 SearchList.GetText(CurSelection,wrk);
 CWordData prac;
 if(!Slovnik.Lookup(wrk,prac)) MessageBox("Neco se posralo");
 CClientDC dc(this);
 UpdateTexts(&dc,prac);
}

void CChildView::UpdateTexts(CDC *adc,CWordData worddata)
{
 PreviousWord=CurrWord;
 CurrWord=worddata;
 int currX,currY,startX,startY,offsetY,offsetX,i;
 TEXTMETRIC tm;

 adc->SelectObject(&NadpisFont);
 //smaze (prepise barvou pozadi) starej napis pokud tam nakej byl
 if (!bFirstUpdate) {
 adc->SetTextColor(RGB(255,255,255));
 adc->TextOut(220,0,PreviousWord.GetKeyWord());
 }
 //vypise novej nadpis
 adc->SetTextColor(RGB(0,0,255));
 adc->TextOut(220,0,worddata.GetKeyWord());
 //ziska startovni pozici pro vypisovani vyznamu
 adc->GetTextMetrics(&tm);
 startX=220;
 startY=tm.tmHeight+tm.tmExternalLeading;
 //zjisti kolik pixelu musime pricist pri posunu na dalsi radek
 adc->SelectObject(&TextFont);
 adc->GetTextMetrics(&tm);
 offsetY=tm.tmHeight+tm.tmExternalLeading;
 //zjisti kolik musime vynechat mista pro cislovani
 adc->SelectObject(&BoldTextFont);
 adc->GetTextMetrics(&tm);
 offsetX=tm.tmAveCharWidth*4;
 adc->SelectObject(&TextFont);
 //prepise barvou pozadi stary vyznamy
 if (!bFirstUpdate) {
 currX=startX+offsetX;
 currY=startY;
 adc->SetTextColor(RGB(255,255,255));
 adc->TextOut(startX+offsetX,startY,PreviousWord.GetFirstWord()); 
 while(!PreviousWord.IsLastWord()) {
 currY=currY+offsetY;
 adc->TextOut(currX,currY,PreviousWord.GetNextWord());
 }
 }

 adc->SetTextColor(RGB(255,255,255));
 adc->SelectObject(&BoldTextFont);
 currX=startX;
 currY=startY;
 //prepise barvou pozadi stary cislovani
 if (!bFirstUpdate) {
 for(i=1;i<=PreviousWord.GetWordsCount();i++) {
 CString wrk;
 wrk.Format("%2d",i);
 adc->TextOut(currX,currY,wrk); 
 currY=currY+offsetY;
 }
 }

 adc->SetTextColor(RGB(255,0,0));
 currX=startX;
 currY=startY;
 //vypise cislovani
 for(i=1;i<=worddata.GetWordsCount();i++) {
 CString wrk;
 wrk.Format("%2d",i);
 adc->TextOut(currX,currY,wrk); 
 currY=currY+offsetY;
 }
 // vypise vyznamy k prave vybranymu heslu
 adc->SelectObject(&TextFont);
 currX=startX+offsetX;
 currY=startY;
 adc->SetTextColor(RGB(0,0,0));
 adc->TextOut(startX+offsetX,startY,worddata.GetFirstWord());
 while(!worddata.IsLastWord()) {
 currY=currY+offsetY;
 adc->TextOut(currX,currY,worddata.GetNextWord());
 }
 VyskaSlov=currY+offsetY;
 if (bFirstUpdate) bFirstUpdate=false;

 if (VyskaOkna < VyskaSlov) {
 int nVScrollMax=VyskaSlov-1;
 VPageSize=VyskaOkna;
 VScrollPos=min(VScrollPos,VyskaSlov-VPageSize);
 SCROLLINFO si;
 si.fMask=SIF_PAGE | SIF_RANGE | SIF_POS;
 si.nMin=0;
 si.nMax=nVScrollMax;
 si.nPos=VScrollPos;
 si.nPage=VPageSize;
 SetScrollInfo(SB_VERT,&si,TRUE);
 }

}

void CChildView::OnSize(UINT nType, int cx, int cy) 
{
	CWnd ::OnSize(nType, cx, cy);
	VyskaOkna=cy;
	DelkaOkna=cx;
 // TODO: Add your message handler code here
SearchList.MoveWindow(0,0,195,cy);
 int nVScrollMax=0;
 VScrollPos=VPageSize=0;

 if (cy<VyskaSlov) {
  nVScrollMax=VyskaSlov;
  VPageSize=cy;
  VScrollPos=min(VScrollPos,VyskaSlov-VPageSize);
 }

 SCROLLINFO si;
 si.fMask=SIF_PAGE | SIF_RANGE | SIF_POS;
 si.nMin=0;
 si.nMax=nVScrollMax;
 si.nPos=VScrollPos;
 si.nPage=VPageSize;
 SetScrollInfo(SB_VERT,&si,TRUE);
}

void CChildView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	
int nDelta;
switch (nSBCode) {
case SB_LINEUP:
 nDelta=-10;
 break;
case SB_PAGEUP:
 nDelta=-VPageSize;
 break;
case SB_THUMBTRACK:
 nDelta=(int)nPos-VScrollPos;
 break;
case SB_PAGEDOWN:
 nDelta=VPageSize;
 break;
case SB_LINEDOWN:
 nDelta=10;
 break;
default:
 return;
}
int nScrollPos=VScrollPos+nDelta;
int nMaxPos=VyskaSlov-VPageSize;

if(nScrollPos<0)
 nDelta=-VScrollPos;
else if (nScrollPos >nMaxPos) nDelta=nMaxPos-VScrollPos;
if (nDelta!=0) {
 VScrollPos+=nDelta;
  SetScrollPos(SB_VERT,VScrollPos,TRUE);
  CRect rc(220,0,DelkaOkna,VyskaOkna);
  ScrollWindow(0,-nDelta,rc);
}
}

void CChildView::OnEditWord() 
{	
CWordDialog wd;
int CurSelection;
CString wrk;

CurSelection=SearchList.GetCurSel();
if (CurSelection!=LB_ERR) {
 SearchList.GetText(CurSelection,wrk);
 CWordData prac;
 if(!Slovnik.Lookup(wrk,prac)) MessageBox("Neco se posralo");
    wd.KeyWord=prac.GetKeyWord();
	prac.GetVyznamy(&wd.Vyznamy,&wd.PocetVyznamu);
	if (wd.DoModal()==IDOK){
	CWordData wrk(wd.KeyWord,&wd.Vyznamy,wd.PocetVyznamu,CurSelection);
    Slovnik[wd.KeyWord]=wrk;
	CClientDC dc(this);
    UpdateTexts(&dc,wrk);
	WasChanged=true;
	char titulek[128]="Slovnik - ";
    strcat(titulek,OpenFile);
    strcat(titulek,"*");
    ::AfxGetMainWnd()->SendMessage(WM_SETTEXT,0,(long)titulek);

	}
}
}

void CChildView::OnDeleteWord() 
{
int CurSelection;
CString wrk;
CWordData prac;

CurSelection=SearchList.GetCurSel();
if (CurSelection!=LB_ERR) {
 SearchList.GetText(CurSelection,wrk);
 if (MessageBox("Chcete smazat heslo:"+wrk+"?","Potvrzeni",MB_YESNO)==IDYES) {
 CClientDC dc(this);
 ResetTexts(&dc);
 Slovnik.RemoveKey(wrk);
 SearchList.DeleteString(CurSelection);
 WasChanged=true;
 char titulek[128]="Slovnik - ";
 strcat(titulek,OpenFile);
 strcat(titulek,"*");
 ::AfxGetMainWnd()->SendMessage(WM_SETTEXT,0,(long)titulek);
 }
}
}

void CChildView::ResetTexts(CDC *adc)
{
 PreviousWord=CurrWord;
 int currX,currY,startX,startY,offsetY,offsetX,i;
 TEXTMETRIC tm;

 adc->SelectObject(&NadpisFont);
 //smaze (prepise barvou pozadi) starej napis pokud tam nakej byl
 if (!bFirstUpdate) {
 adc->SetTextColor(RGB(255,255,255));
 adc->TextOut(220,0,PreviousWord.GetKeyWord());
 }
  //ziska startovni pozici pro vypisovani vyznamu
 adc->GetTextMetrics(&tm);
 startX=220;
 startY=tm.tmHeight+tm.tmExternalLeading;
 //zjisti kolik pixelu musime pricist pri posunu na dalsi radek
 adc->SelectObject(&TextFont);
 adc->GetTextMetrics(&tm);
 offsetY=tm.tmHeight+tm.tmExternalLeading;
 //zjisti kolik musime vynechat mista pro cislovani
 adc->SelectObject(&BoldTextFont);
 adc->GetTextMetrics(&tm);
 offsetX=tm.tmAveCharWidth*4;
 adc->SelectObject(&TextFont);
 //prepise barvou pozadi stary vyznamy
 if (!bFirstUpdate) {
 currX=startX+offsetX;
 currY=startY;
 adc->SetTextColor(RGB(255,255,255));
 adc->TextOut(startX+offsetX,startY,PreviousWord.GetFirstWord()); 
 while(!PreviousWord.IsLastWord()) {
 currY=currY+offsetY;
 adc->TextOut(currX,currY,PreviousWord.GetNextWord());
 }
 }
 adc->SetTextColor(RGB(255,255,255));
 adc->SelectObject(&BoldTextFont);
 currX=startX;
 currY=startY;
 //prepise barvou pozadi stary cislovani
 if (!bFirstUpdate) {
 for(i=1;i<=PreviousWord.GetWordsCount();i++) {
 CString wrk;
 wrk.Format("%2d",i);
 adc->TextOut(currX,currY,wrk); 
 currY=currY+offsetY;
 }
 }
 bFirstUpdate=true;
}

void CChildView::OnNewDict() 
{
	// TODO: Add your command handler code here
if (WasChanged) 
{int result=MessageBox("Slovnik: "+OpenFile+" byl zmenen.Chcete ho ulozit?","Potvrzeni",MB_YESNOCANCEL); 
 if (result==IDCANCEL) return;
 if (result==IDYES) OnSaveDict();}
 SearchList.ResetContent();
 Slovnik.RemoveAll();
 Slovnik.InitHashTable(1701);
 CClientDC dc(this);
 ResetTexts(&dc);
 HasName=false;
 WasChanged=false;
 OpenFile="Bezjmena";
 char titulek[128]="Slovnik - ";
 strcat(titulek,OpenFile);
 ::AfxGetMainWnd()->SendMessage(WM_SETTEXT,0,(long)titulek);
}

void CChildView::OnSaveDictAs() 
{
CString File;
CString Filter ="Slovniky (*.dct)|*.dct|Vsechny Soubory (*.*)|*.*||";
CFileDialog Dlg(FALSE,"dct","*.dct",OFN_LONGNAMES,Filter);
if (Dlg.DoModal()==IDOK) File=Dlg.GetFileName();
	   else return;
if (!SaveDictionary(File)) MessageBox("Chyba pri ukladani dat");
WasChanged=false;
HasName=true;
OpenFile=File;
char titulek[128]="Slovnik - ";
strcat(titulek,OpenFile);
::AfxGetMainWnd()->SendMessage(WM_SETTEXT,0,(long)titulek);
}

int CChildView::SaveDictionary(CString FileName)
{
 CString Sign="Dictionary";

 try {
	CFile file(FileName,CFile::modeCreate | CFile::modeWrite); 
    CArchive ar (&file, CArchive::store); 
     ar<<Sign;
	 ar<<Slovnik.GetCount();
	 POSITION pos=Slovnik.GetStartPosition();
	 while (pos!=NULL) {
	  CString key;
	  CWordData Data;
	  Slovnik.GetNextAssoc(pos,key,Data);
	  Data.Serialize(ar);
	 }
  }
 
 catch (CFileException* e) {
    e->ReportError ();
    e->Delete ();
	return 0;
}

catch(CMemoryException* e){
    e->ReportError ();
    e->Delete ();
	PostQuitMessage(666);
	return 0;
}

catch(CArchiveException* e){
    e->ReportError ();
    e->Delete ();
	return 0;
}

return 1;	
 
}

void CChildView::OnOpenDict() 
{
if (WasChanged) 
{int result=MessageBox("Slovnik: "+OpenFile+" byl zmenen.Chcete ho ulozit?","Potvrzeni",MB_YESNOCANCEL); 
 if (result==IDCANCEL) return;
 if (result==IDYES) OnSaveDict();}
CString File;	
CString Filter ="Slovniky (*.dct)|*.dct|Vsechny Soubory (*.*)|*.*||";
CFileDialog Dlg(TRUE,"dct","*.dct",OFN_LONGNAMES,Filter);
if (Dlg.DoModal()==IDOK) File=Dlg.GetFileName();
	   else return;
SearchList.ResetContent();
Slovnik.RemoveAll();
CClientDC dc(this);
ResetTexts(&dc);
if (!LoadDictionary(File)) MessageBox("Chyba pri nacitani dat");
HasName=true;
WasChanged=false;
OpenFile=File;
char titulek[128]="Slovnik - ";
strcat(titulek,OpenFile);
::AfxGetMainWnd()->SendMessage(WM_SETTEXT,0,(long)titulek);
}

int CChildView::LoadDictionary(CString FileName)
{
CString Sign="";
int i,j,k,l,counter; 
bool prime=false;
try {
	CFile file(FileName,CFile::modeRead); 
    CArchive ar (&file,CArchive::load); 
     ar>>Sign;
	 if (Sign!="Dictionary") return 0;
     ar>>counter;
	 j=counter+counter/5+500;
     l=(int)sqrt(j);
	 while(!prime)
	 {
	 for(k=2;k<=l;k++) if (j%k==0) break;
	 if (k==l+1) prime=true;
	 else j++;
     l=(int)sqrt(j);
	 }
	 Slovnik.InitHashTable(j);
	 for(i=0;i<counter;i++) {
     CWordData Data;
	 Data.Serialize(ar);
	 Slovnik[Data.GetKeyWord()]=Data;
	 SearchList.AddString(Data.GetKeyWord());
	 }
}

catch (CFileException* e) {
    e->ReportError ();
    e->Delete ();
	return 0;
}

catch(CMemoryException* e){
    e->ReportError ();
    e->Delete ();
	PostQuitMessage(666);
	return 0;
}

catch(CArchiveException* e){
    e->ReportError ();
    e->Delete ();
	return 0;
}

 return 1;
}



void CChildView::OnMergeDict() 
{
	// TODO: Add your command handler code here
CString File;	
CString Filter ="Slovniky (*.dct)|*.dct|Vsechny Soubory (*.*)|*.*||";
CFileDialog Dlg(TRUE,"dct","*.dct",OFN_LONGNAMES,Filter);
if (Dlg.DoModal()==IDOK) File=Dlg.GetFileName();
	   else return;
if (!LoadDictionary(File)) MessageBox("Chyba pri nacitani dat");
WasChanged=true;
char titulek[128]="Slovnik - ";
strcat(titulek,OpenFile);
strcat(titulek,"*");
::AfxGetMainWnd()->SendMessage(WM_SETTEXT,0,(long)titulek);

}


void CChildView::OnSaveDict() 
{
	// TODO: Add your command handler code here
CString File=OpenFile;
if (!HasName) {
  CString Filter ="Slovniky (*.dct)|*.dct|Vsechny Soubory (*.*)|*.*||";
  CFileDialog Dlg(FALSE,"dct","*.dct",OFN_LONGNAMES,Filter);
   if (Dlg.DoModal()==IDOK) File=Dlg.GetFileName();
   else return;}
if (!SaveDictionary(File)) MessageBox("Chyba pri ukladani dat");
WasChanged=false;
char titulek[128]="Slovnik - ";
strcat(titulek,OpenFile);
::AfxGetMainWnd()->SendMessage(WM_SETTEXT,0,(long)titulek);
HasName=true;
OpenFile=File;
}


bool CChildView::ConfirmExit()
{
if (WasChanged) 
{int result=MessageBox("Slovnik: "+OpenFile+" byl zmenen.Chcete ho ulozit?","Potvrzeni",MB_YESNOCANCEL); 
 if (result==IDCANCEL) return false;
 if (result==IDYES) OnSaveDict();}
if (OpenFile!="Bezjmena") WritePrivateProfileString("Slovnik",
													"LastFile",OpenFile,"./slovnik.ini");
return true;
}

void CChildView::OnFindWord() 
{	
FindWordDiag fw;
fw.DoModal();
FindWord(fw.m_Word);
}

bool CChildView::FindWord(CString word)
{
int res=SearchList.SelectString(-1,word );
if (SearchHistory.Find(word)==NULL) {
SearchHistory.AddTail(word);
if (SearchHistory.GetCount()>50) SearchHistory.RemoveHead();
::AfxGetMainWnd()->SendMessage(WM_USER+2,0,0);
}
if (res==LB_ERR) return false;
CString text;
SearchList.GetText(res,text);
CWordData wrk;
if(!Slovnik.Lookup(text,wrk)) MessageBox("Neco se posralo");
CClientDC dc(this);
UpdateTexts(&dc,wrk);
return true;
}

void CChildView::OnZarad() 
{
	// TODO: Add your command handler code here
int CurSelection;
CString wrk;

CurSelection=SearchList.GetCurSel();
if (CurSelection!=LB_ERR) {
SearchList.GetText(CurSelection,wrk);
CZaradDiag zd;
zd.Title="Zaradit heslo '"+wrk+"' pod tema:";
zd.Heslo=wrk;
zd.DoModal();
}
}

void CChildView::OnTemata() 
{
	// TODO: Add your command handler code here
TemataDiag td;
td.DoModal();
}

void CChildView::OnZkouseni() 
{
	// TODO: Add your command handler code here
VyberTemaDiag vt;
ZkouseniDiag zd;
PridatHesloDiag phd;
CString str;
CWordDialog wd;
bool bAnoVsem=false,bNeVsem=false;
int res;

vt.Title="Vyberte temata pro Zkouseni.";
vt.m_Zobrazovat=0;
vt.Rychlost=2000;
if (vt.DoModal()==IDOK) {
    zd.Rychlost=vt.Rychlost;
	zd.bNahodne=vt.m_Zobrazovat;
	for(int i=0;i<vt.PocetHesel;i++) {
	CWordData wrk;
	if (!Slovnik.Lookup(vt.Hesla[i],wrk)) {
	if (!bNeVsem) {
	if (!bAnoVsem) {
	phd.Heslo=vt.Hesla[i];
	res=phd.DoModal();}
	if (res==IDC_NOALL) bNeVsem=true;
	if (res==IDC_YESALL) bAnoVsem=true;
	if (res==IDYES || bAnoVsem) {
	wd.KeyWord=vt.Hesla[i];
	wd.Vyznamy.RemoveAll();
	wd.PocetVyznamu=0;
	if(wd.DoModal()==IDOK){
	int x=SearchList.AddString(wd.KeyWord);
    CWordData prac(wd.KeyWord,&wd.Vyznamy,wd.PocetVyznamu,x);
    Slovnik[wd.KeyWord]=prac;
    WasChanged=true;
	zd.PocetHesel++;
	try{
	zd.Hesla.SetAtGrow(zd.PocetHesel-1,prac);
	}
	catch(CMemoryException *e) {
	 AfxMessageBox("Nedostatek pameti.");
	 e->Delete();
	 PostQuitMessage(666);
	}
	}
	}
	}
	} else {
	zd.PocetHesel++;
	try{
	zd.Hesla.SetAtGrow(zd.PocetHesel-1,wrk);
	}
	catch(CMemoryException *e) {
	 AfxMessageBox("Nedostatek pameti.");
	 e->Delete();
	 PostQuitMessage(666);
	}
	}
	}
zd.DoModal();
}
}

void CChildView::OnUceni() 
{
	// TODO: Add your command handler code here
VyberTemaDiag vt;
UceniDiag ud;
PridatHesloDiag phd;
CString str;
CWordDialog wd;
bool bAnoVsem=false,bNeVsem=false;
int res;

vt.m_Zobrazovat=0;
vt.Rychlost=2000;
vt.Title="Vyberte temata pro uceni.";
if (vt.DoModal()==IDOK){
	ud.bNahodne=vt.m_Zobrazovat;
	for(int i=0;i<vt.PocetHesel;i++) {
    ud.Rychlost=vt.Rychlost;
	CWordData wrk;
	if (!Slovnik.Lookup(vt.Hesla[i],wrk)) {
	if (!bNeVsem) {
	if (!bAnoVsem) {
	phd.Heslo=vt.Hesla[i];
	res=phd.DoModal();}
	if (res==IDC_NOALL) bNeVsem=true;
	if (res==IDC_YESALL) bAnoVsem=true;
	if (res==IDYES || bAnoVsem) {
	wd.KeyWord=vt.Hesla[i];
	wd.Vyznamy.RemoveAll();
	wd.PocetVyznamu=0;
	if(wd.DoModal()==IDOK){
	int x=SearchList.AddString(wd.KeyWord);
    CWordData prac(wd.KeyWord,&wd.Vyznamy,wd.PocetVyznamu,x);
    Slovnik[wd.KeyWord]=prac;
    WasChanged=true;
	ud.PocetHesel++;
	try{
	ud.Hesla.SetAtGrow(ud.PocetHesel-1,prac);
	}
	catch(CMemoryException *e) {
	 AfxMessageBox("Nedostatek pameti.");
	 e->Delete();
	 PostQuitMessage(666);
	}
	}
	}
	}
	} else {
	ud.PocetHesel++;
	try{
	ud.Hesla.SetAtGrow(ud.PocetHesel-1,wrk);
	}
	catch(CMemoryException *e) {
	 AfxMessageBox("Nedostatek pameti.");
	 e->Delete();
	 PostQuitMessage(666);
	}
	}
    }
ud.DoModal();
}
}
